int carX;
int carSpeed;
int leftWall;
int roadWidth;
int distance;
int speedOffset;
int oldOffset;

void race_loop()
{
  speedOffset=0;
  if (!(PINC & 0x02)) carX--;  // PORT C pin 1 is attached to left button
  if (!(PINC & 0x10)) carX++;  // PORT C pin 4 is attached to right button
  if (!(PINC & 0x04)) speedOffset=-5;  // PORT C pin 1 is attached to left button
  if (!(PINC & 0x08)) speedOffset=+5;  // PORT C pin 1 is attached to left button
  if (speedOffset != oldOffset) {
     notePlayer.play(600+(40*speedOffset));
     oldOffset=speedOffset;
  }
  if (frame4.GetPoint(carX,gameMaxY-2)) {
    // HIT!
    notePlayer.stop();
    display_score();
    race_setup_game();
  }
  
  for (uint8_t i=gameMaxY;i>gameMinY;i--){
    frame4.buffer[i]=frame4.buffer[i-1];
    frame2.buffer[i]=frame2.buffer[i-1];
    frame1.buffer[i]=frame1.buffer[i-1];
  }
  frame4.buffer[0]=0;
  frame2.buffer[0]=0;
  frame1.buffer[0]=0;
  int offset = random(3)-1;
  leftWall=leftWall+offset;
  if (leftWall < gameMinX) leftWall=gameMinX;
  if ((leftWall+roadWidth) > gameMaxX) leftWall=gameMaxX-roadWidth;
  for (int i=gameMinX;i<leftWall;i++) {
    setPixel(i,gameMinY,random(7)+1);
  }
  for (int i=(leftWall+roadWidth+1);i<=gameMaxX;i++) {
    setPixel(i,gameMinY,random(7)+1);
  }
  setPixel(leftWall,gameMinY,7);
  setPixel(leftWall+roadWidth,gameMinY,7);

  setPixel(carX,gameMaxY-1,7);
  refresh_display(carSpeed-speedOffset);
  distance++;
  if ((distance % 25) == 0) {
    points=distance/25;
    update_scorebar();
    if ((points % 25) == 0 ){
      level++;
      roadWidth--;
    }
  }

}

void race_setup_game()
{
  clear_display();
  roadWidth=10;
  leftWall=gameCentreX-(roadWidth/2);
  carX=gameCentreX;
  carSpeed=10;
  points=0;
  distance=0;
  level=1;
  speedOffset=0;
  oldOffset=99;
}

