
int introTune[] = {NOTE_C5, NOTE_C5, NOTE_G5, NOTE_G5, NOTE_A5, NOTE_A5, NOTE_G5, 0,
                   NOTE_F4, NOTE_F4, NOTE_E4, NOTE_E4, NOTE_D4, NOTE_D4, NOTE_C4, 0};
int introTuneSteps = 16;
int tuneStep = 0;
unsigned long time = 0;
int duration = 200;
int gap = duration + 50;

void playMelody()
{
  unsigned long offset = millis() - time;
  if (offset > duration) {
    if (offset < gap ) {
      notePlayer.stop();
    } else {
      if (introTune[tuneStep]) notePlayer.play(introTune[tuneStep]);
      tuneStep++;
      if (tuneStep == introTuneSteps) tuneStep=0;
      time=millis();
    }
  }
}
